from services.basicservice import BasicService
from servicestub import ServiceStub
from singleton import Singleton
import os


class DeferredCheck(BasicService, metaclass=Singleton):

    def __init__(self):
        super().__init__(os.path.dirname(os.path.abspath(__file__)))
    
    def registerRoutes(self, servicestub: ServiceStub):
        self.log.info('Регистрация сервиса отложенных чеков')
        self._loadCases('cases.json')
        servicestub.route('/CSrest/rest/dictionaries/pendingchecks', method='POST', callback=self.addCheck)
        servicestub.route('/CSrest/rest/dictionaries/pendingchecks/<checkId>', method='GET', callback=self.getCheck)
        servicestub.route('/CSrest/rest/dictionaries/pendingchecks/<checkId>', method='PUT', callback=self.updateCheck)
        servicestub.route('/CSrest/rest/dictionaries/pendingchecks/bypage', method='GET', callback=self.getChecks)
        
    def addCheck(self):
        self.log.info('Добавление отложенного чека')
        methodPath = '/pendingchecks'
        
        return self._createResponse(methodPath)

    def getCheck(self, checkId):
        self.log.info(f'Получение отложенного чека: {checkId}')
        methodPath = '/pendingchecks_get'

        return self._createResponse(methodPath)
    
    def updateCheck(self, checkId):
        self.log.info(f'Обновление отложенного чека: {checkId}')
        methodPath = '/pendingchecks_put'

        return self._createResponse(methodPath)
    
    def getChecks(self):
        self.log.info('Получение списка отложенных чеков')
        methodPath = '/bypage'

        return self._createResponse(methodPath)


instance = DeferredCheck()
