from services.basicservice import BasicService
from servicestub import ServiceStub
from singleton import Singleton
import os


class KilBil(BasicService, metaclass=Singleton):
    
    def __init__(self):
        super().__init__(os.path.dirname(os.path.abspath(__file__)))
    
    def registerRoutes(self, servicestub: ServiceStub):
        self.log.info('Регистрация сервиса kilbil')
        self._loadCases('cases.json')
        servicestub.route('/load/searchclient', method='POST', callback=self.searchClient)
        servicestub.route('/load/processsale', method='POST', callback=self.processSale)
        servicestub.route('/load/confirmsale', method='POST', callback=self.confirmSale)
    
    def searchClient(self):
        self.log.info("Поиск клиента")
        methodPath = '/load/searchclient'

        return self._createResponse(methodPath)
    
    def processSale(self):
        self.log.info("Расчет документа")
        methodPath = '/load/processsale'

        return self._createResponse(methodPath)
    
    def confirmSale(self):
        self.log.info("Подтверждение документа")
        methodPath = '/load/confirmsale'

        return self._createResponse(methodPath)
    
    
instance = KilBil()
